import { LOCATION, FEATURE_PROPS } from '../variables';

window.map = null;

async function main() {
    await ymaps3.ready;

    const {
        YMap,
        YMapDefaultSchemeLayer,
        YMapDefaultFeaturesLayer,
        YMapFeature,
        YMapMarker,
    } = ymaps3;

    // Создаём карту
    map = new YMap(
        document.getElementById('app'),
        { location: LOCATION, showScaleInCopyrights: true },
        [
            new YMapDefaultSchemeLayer({}),
            new YMapDefaultFeaturesLayer({}),
        ]
    );

    // Добавляем линию
    const line = new YMapFeature(FEATURE_PROPS);
    map.addChild(line);

    // Функция для создания маркера с подсказкой
    function createMarker(coordinates: [number, number], hintText: string, iconUrl: string) {
        const container = document.createElement('div');
        container.classList.add('marker-container');

        const hint = document.createElement('div');
        hint.classList.add('marker-text', 'hidden');
        hint.innerText = hintText;

        container.onmouseover = () => {
            hint.classList.replace('hidden', 'visible');
        };
        container.onmouseout = () => {
            hint.classList.replace('visible', 'hidden');
        };

        const markerDiv = document.createElement('div');
        markerDiv.classList.add('marker');

        const img = document.createElement('img');
        img.src = iconUrl;
        img.classList.add('image');

        markerDiv.appendChild(img);
        container.appendChild(hint);
        container.appendChild(markerDiv);

        return new YMapMarker(
            { coordinates },
            container
        );
    }

    // Пример маркеров
    const markers = [
        createMarker(
            [116.525834, 50.392417],
            'Старт: 10:00 – 12:00 Городской велопробег, посвящённый Дню России и Дню города',
            'https://xn----btbeer2badnf0o.xn--p1ai/images/start.svg'
        ),
        // Добавьте другие маркеры здесь по необходимости
    ];

    // Добавляем маркеры на карту
    markers.forEach(marker => map.addChild(marker));
}

main();
